=begin
Copyright 2009, TIG
Permission to use, copy, modify, and distribute this software for 
any purpose and without fee is hereby granted, provided the above
copyright notice appear in all copies.
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------
Name        : TextAScreenVis.rb
Description : Toggles dimensions on/off [hidden/shown]
Menu Item   : View -> Dimensions (Toggle)
              For ease of use it's best with a shortcut key...
Author      : TIG
Usage       : Pick off menu or shortcut key 
              (or type textscreenvis in the Ruby console).
              Then all dimensions are either shown or hidden.
              If it's the first time it's used that session then the 
              dimensions are shown, so if you want to hide then 
              initially use it twice the first time...
              One step undo-able...
Version     : 1.0 First draft. 20090404
              1.1 Undo added.  Mining groups/definitions. 20090405
=end
require 'sketchup.rb'
def TextScreenVis()
  def TextScreenVisOFF(ents)
    ents.each{|e|
      e.hidden=true if e.typename=="Text"
      TextScreenVisOFF(e.entities)if e.typename=="Group"
      TextScreenVisOFF(e.definition.entities)if e.typename=="ComponentInstance"
    }
  end#def
  def TextScreenVisON(ents)
    ents.each{|e|
      e.hidden=false if e.typename=="Text" and e.leader_type==0
      TextScreenVisON(e.entities)if e.typename=="Group"
      TextScreenVisON(e.definition.entities)if e.typename=="ComponentInstance"
    }
  end#def
  model=Sketchup.active_model
  model.start_operation("ScreenText Visibility Toggle")
  if $dims_visible
    TextScreenVisOFF(model.entities)
    $dims_visible=false
  else
    TextScreenVisON(model.entities)
    $dims_visible=true
  end#if
  model.commit_operation
end#def
if not file_loaded?(__FILE__)
	UI.menu("View").add_item("Text, Screen (Toggle) - [TextScreenVis.rb TIG]"){TextScreenVis()}
end#if
file_loaded(__FILE__)
